
	section code

;********* Timer C init and restore ***********************************

	public	_set_timerC
_set_timerC:
	pea	superv(pc)	; put the address of the routine on the stack 
	move.w	#38,-(a7)	; put the function number on the stack 
	trap	#14		; call the XBIOS function 
	addq.l	#6,a7		; tidy the stack 
	rts
superv:	move.l	$114.w,_old_timer
	move.l	#timerC,$114.w
	rts

timerC:
	addq.l	#1,_timer_tick
	cmp.b	#$39,$fffffc02.w	; space pressed? 
	bne.s	_nospace
	move.l	#1,_space_pressed
_nospace:		
	move.l	_old_timer,-(sp)
	rts

	even
	public	_timer_tick
_timer_tick:	dc.l	0
_old_timer:	dc.l	0

	public	_space_pressed
_space_pressed:	dc.l	0

	public	_restore_timerC
_restore_timerC:	
	pea	superv2(PC)	; put the address of the routine on the stack 
	move.w	#38,-(A7)	; put the function number on the stack 
	trap	#14		; call the XBIOS function 
	addq.w	#6,A7		; tidy the stack 
	rts
superv2:
	move.l	_old_timer,$114.w
	rts

;********* Timer B init and restore ***********************************

	public	_set_timerB
_set_timerB:	
	pea	superv1(pc)	; put the address of the routine on the stack 
	move.w	#38,-(a7)	; put the function number on the stack 
	trap	#14		; call the XBIOS function 
	addq.l	#6,a7		; tidy the stack 
	rts
superv1:
	move.l	$70.w,_old_vbl
	move.l	#timerB,$70.w
        rts
timerB:
	tst.w	_new_frame
	beq	nonewframe
	movem.l	d0-d1,-(sp)
	move.l	_screen_adr3,d0	; set screen 
	move.l	d0,d1					
	lsr.w	#8,d0					
	move.l	d0,$ffff8200.w
	move.b	d1,$ffff820d.w
	movem.l	(sp)+,d0-d1
nonewframe:		
	clr.w	_new_frame
	move.l	_old_vbl,-(sp)
	rts

	public	_new_frame
_new_frame:	dc.w	0
_old_vbl:	dc.l	0

	public	_restore_timerB
_restore_timerB:	
	pea	superv3(PC)	; put the address of the routine on the stack 
	move.w	#38,-(A7)	; put the function number on the stack 
	trap	#14		; call the XBIOS function 
	addq.w	#6,A7		; tidy the stack 
	rts
superv3:
	move.l	_old_vbl,$70.w
	rts

;*************** Setup screens and malloc video ram ********************

	public	_screen_init
_screen_init:
	clr.w	-(sp)			; Mxalloc() 
	move.l	#320*240*2*3+256,-(sp)	; size of all screens 
	move.w	#$44,-(sp)			
	trap	#1
	addq.l	#8,sp
	tst.l	d0			; ramcheck 
	beq.w	init_failed		; ok 
	add.l	#256,d0			; make even address 
	clr.b	d0				
	move.l	#320*240,d1		; screensize 
	lea.l	_screen_adr,a0		; screen addresses 
	move.l	d0,(a0)+		; screen_adr 
	add.l	d1,d0				
	move.l	d0,(a0)+		; screen_adr2 
	add.l	d1,d0				
	move.l	d0,(a0)			; screen_adr3 

	pea	superv_scr(PC)	; put the address of the routine on the stack 
	move.w	#38,-(A7)	; put the function number on the stack 
	trap	#14		; call the XBIOS function 
	addq.w	#6,A7		; tidy the stack 
	clr.l	d0		;return ok
	rts
init_failed:
	move.l	#-1,d0		;return fail
	rts

	; supervisor video init 
superv_scr:	
	lea.l	$ffff9800.w,a0		; save falcon palette 
	lea.l	save_pal,a1				
	move.w	#256-1,d7				
colloop:	
	move.l	(a0)+,(a1)+			
	dbra	d7,colloop				
	movem.l	$ffff8240.w,d0-d7	; save st palette 
	movem.l	d0-d7,(a1)			
	lea.l	save_video,a0		; store videomode 
	move.l	$ffff8200.w,(a0)+	; vidhm 
	move.w	$ffff820c.w,(a0)+	; vidl 
	move.l	$ffff8282.w,(a0)+	; h-regs 
	move.l	$ffff8286.w,(a0)+			
	move.l	$ffff828a.w,(a0)+			
	move.l	$ffff82a2.w,(a0)+	; v-regs 
	move.l	$ffff82a6.w,(a0)+			
	move.l	$ffff82aa.w,(a0)+			
	move.w	$ffff82c0.w,(a0)+	; vco 
	move.w	$ffff82c2.w,(a0)+	; c_s 
	move.l	$ffff820e.w,(a0)+	; offset 
	move.w	$ffff820a.w,(a0)+	; sync 
	move.b  $ffff8256.w,(a0)+	; p_o  
	clr.b   (a0)			; test of st(e) or falcon mode 
	cmp.w   #$b0,$ffff8282.w	; hht kleiner $b0? 
	sle     (a0)+			; flag setzen 
	move.w	$ffff8266.w,(a0)+	; f_s  
	move.w	$ffff8260.w,(a0)+	; st_s 
	rts

	public	_video_320_240_8
_video_320_240_8:
        pea	video_320_240_8(PC)
        move.w	#38,-(A7)
        trap	#14	
        addq.w	#6,A7	
	rts	
video_320_240_8:
	move.l	 #$c60097,$ffff8282.w
	move.l	 #$80298,$ffff8286.w
	move.l	 #$790097,$ffff828a.w
	move.l	 #$41903ff,$ffff82a2.w
	move.l	 #$3f003d,$ffff82a6.w
	move.l	 #$3fd0415,$ffff82aa.w
	move.w	 #$200,$ffff820a.w
	move.w	 #$186,$ffff82c0.w
	clr.w	 $ffff8266.w
	move.w	 #$10,$ffff8266.w
	move.w	 #$05,$ffff82c2.w
	move.w	 #$a0,$ffff8210.w
	rts

	public	_video_320_200_4
_video_320_200_4:
	pea	video_320_200_4(PC)
	move.w	#38,-(A7)
	trap	#14	
	addq.w	#6,A7	
	rts	
video_320_200_4:
	move.l  #$170012,$ffff8282.w       ; falcon 60Hz vga 
	move.l  #$1020e,$ffff8286.w             
	move.l  #$d0012,$ffff828a.w             
	move.l	#$41903ff,$ffff82a2.w           
	move.l  #$3f008d,$ffff82a6.w            
	move.l  #$3ad0415,$ffff82aa.w           
	move.w  #$200,$ffff820a.w   
	move.w	#$186,$ffff82c0.w               
	clr.w   $ffff8266.w                     
	clr.b   $ffff8260.w                     
	move.w  #$5,$ffff82c2.w 
	move.w	#$50,$ffff8210.w                
	rts

setvideo:
	tst.w	monitor			; vga? 
	bne	rgb			; >rgb 
	cmp.w	#60,vga_freq		; 60Hz vga? 
	bne.s	vga100			; >100Hz 
	bra.s	setres			; set 60Hz vga 
vga100:
	lea.l	36*1(a0),a0		; set 100Hz vga 
	bra.s	setres				
rgb:
	cmp.w	#50,rgb_freq		; 50Hz rgb? 
	bne.s	rgb60			; >60Hz 
	lea.l	36*2(a0),a0		; set 50Hz rgb 
	bra.s	setres				
rgb60:
	lea.l	36*3(a0),a0		; set 60Hz rgb 

setres:
	move.l	(a0)+,$ffff8282.w	; horizontal hold timer 
	move.l	(a0)+,$ffff8286.w	; horizonal border end 
	move.l	(a0)+,$ffff828a.w	; horizontal display end 
	move.l	(a0)+,$ffff82a2.w	; vertical frequency timer 
	move.l	(a0)+,$ffff82a6.w	; vertical border end 
	move.l	(a0)+,$ffff82aa.w	; vertical display end 
	move.w	(a0)+,$ffff820a.w	; video sync mode 
	move.w	(a0)+,$ffff82c0.w	; video clock 
	clr.w	$ffff8266.w		; spshift - videl colourmode 
	move.l	(a0)+,d0			
	bmi.s	st_comp			
	clr.b	$ffff8260.w		; st shifter resolution 
	move.w	d0,$ffff8266.w		; spshift - videl colourmode 
	bra	set_video			
st_comp:
	clr.w	$ffff8266.w		; spshift - videl colourmode 
	swap	d0				
	move.b	d0,$ffff8260.w		; st shifter resolution 
set_video:
	move.w	(a0)+,$ffff82c2.w	; vco - videl pixel width 
	move.w	(a0)+,$ffff8210.w	; scanlinewidth 	
	rts
	
save_pal:	ds.l	256+8
save_video:	ds.l	32+12+2

monitor:	dc.w	0	 	; use vga 
vga_freq:	dc.w	60
rgb_freq:	dc.w	50

;*************** Restore screen ****************************************
	
	public	_screen_restore
_screen_restore:
	pea	superv_rest(PC)	; put the address of the routine on the stack 
	move.w	#38,-(A7)	; put the function number on the stack 
	trap	#14		; call the XBIOS function 
	addq.w	#6,A7		; tidy the stack 
	rts
	
superv_rest:		
	lea.l	save_video,a0		; restore video 
	clr.w   $ffff8266.w		; falcon-shift clear  
	move.l	(a0)+,$ffff8200.w	; videobase_address:h&m 
	move.w	(a0)+,$ffff820c.w	; l 
	move.l	(a0)+,$ffff8282.w	; h-regs 
	move.l	(a0)+,$ffff8286.w			
	move.l	(a0)+,$ffff828a.w			
	move.l	(a0)+,$ffff82a2.w	; v-regs 
	move.l	(a0)+,$ffff82a6.w			
	move.l	(a0)+,$ffff82aa.w			
	move.w	(a0)+,$ffff82c0.w	; vco 
	move.w	(a0)+,$ffff82c2.w	; c_s  
	move.l	(a0)+,$ffff820e.w	; offset 
	move.w	(a0)+,$ffff820a.w	; sync 
	move.b  (a0)+,$ffff8256.w	; p_o 
	tst.b   (a0)+			; st(e) comptaible mode? 
	bne.s   okii
	move.l	a0,-(sp)		; wait for vbl 
	move.w	#37,-(sp)		; to avoid syncerrors  
	trap	#14			; in falcon monomodes 
	addq.l	#2,sp					
	movea.l	(sp)+,a0				
	move.w  (a0),$ffff8266.w	; falcon-shift 
	bra.s	video_restored
okii:
	move.w  2(a0),$ffff8260.w	; st-shift 
	lea.l	save_video,a0
	move.w	32(a0),$ffff82c2.w	; c_s 
	move.l	34(a0),$ffff820e.w	; offset 
video_restored:
	lea.l	$ffff9800.w,a0		; restore falcon palette 
	lea.l	save_pal,a1				
	move.w	#256-1,d7				
loop:
	move.l	(a1)+,(a0)+				
	dbra	d7,loop				
	movem.l	(a1),d0-d7		; restore st palette 
	movem.l	d0-d7,$ffff8240.w			
	rts

;*************** Set palette  ******************************************

	public	_set_palette
_set_palette:
	pea	superv_palette(PC)	; put the address of the routine on the stack 
	move.w	#38,-(A7)		; put the function number on the stack 
	trap	#14			; call the XBIOS function 
	addq.w	#6,A7			; tidy the stack 
	rts

superv_palette:
	lea.l	_palette_256,a0		; adr to palette 
	lea.l	$ffff9800.w,a1
	move.w	#256-1,d7
plop:
	move.l	(a0)+,(a1)+
	dbra	d7,plop
	rts

	public	_palette_256
_palette_256:	ds.l	256

;*************** Screen swap (and tell vbl to swap...) *******************

	;wait for vbl if we run faster than one frame
	public	_screen_swap_wait_vbl
_screen_swap_wait_vbl:
	tst.w	_new_frame
	bne.s	_screen_swap_wait_vbl

	;do not wait for vbl if we run faster than one frame
	public 	_screen_swap
_screen_swap:
	move.l	_screen_adr,d0		; swapscreens 
	move.l	_screen_adr2,_screen_adr			
	move.l	_screen_adr3,_screen_adr2			
	move.l	d0,_screen_adr3				
	addq.w	#1,_new_frame		; tell vbl int to update this vbl 
	rts

	public	_screen_adr
_screen_adr:	dc.l	0
_screen_adr2:	dc.l	0
_screen_adr3:	dc.l	0

;*************** Screen clear ******************************************

	public	_screen_clear
_screen_clear:
	move.l	_screen_adr,a0
	move.l	#288*200*2/4/4-1,d0
clr:
	clr.l	(A0)+
	clr.l	(A0)+
	clr.l	(A0)+
	clr.l	(A0)+
	dbra	d0,clr
	rts
	
	public	_screen_clear_8bit
_screen_clear_8bit:
	move.l	_chunky,a0
	move.l	#320*240/4/4-1,d0
clr8:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra	d0,clr8
	rts

	public	_screen_clear_4bit
_screen_clear_4bit:
	move.l	_chunky,a0
	move.l	#320*200/2/4/4-1,d0
clr4:
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	clr.l	(a0)+
	dbra	d0,clr4
	rts
	
;*************** Malloc ST RAM *****************************************	
		
	public	_malloc_stram
_malloc_stram:
	clr.w	-(sp)			; Mxalloc() 
	move.l	#320*240*2+256,-(sp)	; size of one screen 
	move.w	#$44,-(sp)
	trap	#1			
	addq.l	#8,sp				
	add.l	#256,d0			; make even address 
	clr.b	d0		
	rts

;************************ Space check *********************************	
			
	public	_chk_space
_chk_space:
	move.w	#$ff,-(sp)
	move.w	#$6,-(sp)		
	trap	#1
	addq.l	#4,sp
	rts

;************************* Math functions *****************************

	public	_ffsin
_ffsin:
	fmove.s 4(a7),fp0
	fsin.x	fp0,fp0
	rts

	public	_ffcos
_ffcos:
	fmove.s 4(a7),fp0
	fcos.x	fp0,fp0
	rts

	public	_fftan
_fftan:
	fmove.s 4(a7),fp0
	ftan.x	fp0,fp0
	rts

	public	_ffsqrt
_ffsqrt:
	fmove.s 4(a7),fp0
	fsqrt.x	fp0,fp0
	rts

	public	_ffexp
_ffexp:
	fmove.s 4(a7),fp0
	fetox.x	fp0,fp0
	rts
	
	public	_ffasin
_ffasin:
	fmove.s 4(a7),fp0
	fasin.x	fp0,fp0
	rts
