#ifndef DEMO_H
#define DEMO_H

#define Uint8 unsigned char

/* Global pointer to the screen. */
/* Use this to write pixels to the screen! */
extern short int *screen_adr;

/* Shut off the system */
int screen_init();

/* Restore the system */
void screen_restore();

/* Swap the triple buffered screen */
void screen_swap();

/* Swap the triple buffered screen */
/* Wait for VBL if we run faster than one vbl */
void screen_swap_wait_vbl();

/* Open a 320x200x4 screen */
void video_320_200_4();

/* Open a 320x240x8 screen */
void video_320_240_8();

/* Perform a 6 plane chunky to planar conversion */
void c2p_6pl();

/* Set the palette from palette_256[] */
void setpalette(char *);

/* Clear the screen */
void screen_clear_4bit();
void screen_clear_8bit();

/* Malloc 320x240 bytes st ram */
short int * malloc_stram();

/* Initialize the timer C */
void set_timerC();
void restore_timerC();

/* Initialize the timer B */
void set_timerB();
void restore_timerB();

/* Returns !=0 if if the user has pressed space. */ 
char chk_space();

/* The total amout of elapsed time */
extern int timer_tick;

/* Pointer to the chunky screen */
extern unsigned char *chunky;

/* Array of palette entries */
extern unsigned int palette_256[256];

/* Internal variables. Do not use... */
extern int space_pressed;
extern int vbl_cnt;

/* Defines for screen size. Should not be changed. */
#define XSCR 320
#define YSCR 240

/* Math functions using the 68882 CPU directly */
float ffsin(float);
float ffcos(float);
float fsin(float);
float fcos(float);
float fsqrt(float);
float ffsqrt(float);
float ftan(float);
float fexp(float);
float ffabs(float);
float fpow(float,int);
float fasin(float);
float ffasin(float);

#define POW3(pp3) (pp3*pp3*pp3)
#define POW2(pp2) (pp2*pp2)
#define M_PI 3.14152
#define gceil(cc) (int)(cc+0.999999)
#define gfloor(cc) (int)(cc)

#endif
