#include <stdio.h>
#include "demo.h"

unsigned char *chunky;
void calc_palette_64();

int main(int argc,char **argv)
{
	int montype,vidmode,vidmode_old;
	int t_main;
	int i,x,y;

	printf("\n\rVbcc demo system init:\n\r");
	chunky = (unsigned char *) malloc(320*240*sizeof(unsigned char));
	if(chunky == NULL)
	{
		printf("Out of memory for chunky buffer\n\r");
		exit(-1);
	}	
	set_timerC();
	set_timerB();
	printf("Initialization done\n\r");

	if(screen_init() < 0)
	{
		printf("Screen init failed!\n\r");
		exit(-1);
	}
	video_320_240_8();
	calc_palette_64();
	set_palette();

	/* blank the screens */
	for(i=0 ; i<3 ; screen_clear(), screen_swap(), i++);

	/* reset timer */
	timer_tick=0; t_main=0;
	while(!space_pressed)
	{
		screen_clear_8bit();
		for(i=1;i<128;i++)
		{
			x = 160+100*ffsin((timer_tick*0.5543+i)*0.0201);
			y = 120+100*ffcos((timer_tick*0.5543+i)*0.0253);
			chunky[320*y+x] = i/2;
		}
		c2p_6pl();
		screen_swap_wait_vbl();
		t_main++;
	}
	restore_timerC();
	restore_timerB();
	screen_restore();
	free(chunky);
	
	fflush(stdin); fflush(stdout);
	printf("Stats: \n\r");
	/* there is some bug with the format string !?!?! */
	printf("%d %d displayed frames in \n\r", t_main,t_main); 
	printf("%d %d vbl's\n\r", timer_tick,timer_tick);

 	exit(0);
}

void calc_palette_64()
{
	int i,r,g,b;
	for(i=0;i<64;i++)
	{
		r=g=b=i*4;
		palette_256[i] = ((int)r<<24) + ((int)g<<16) + ((int)b);
	}
	for(i=64;i<256;i++)
	palette_256[i]=0;
}
